#pragma once

#include <string>
#include <thread>
#include <memory>

enum BinarySocketRet
{
    BINARY_SOCKET_RET_OK = 0,
    BINARY_SOCKET_RET_NG = -1
};

class BinarySocket
{
    public:
        BinarySocket();
        ~BinarySocket();

        BinarySocketRet Initialize();
        BinarySocketRet Finalize();
        BinarySocketRet RestartSocket();
        BinarySocketRet StartReceive();
        BinarySocketRet StopReceive();
        BinarySocketRet SendReplyMessage(std::string i_reply_msg);
        void RegisterCallbackFunc(std::function<void(std::string)> i_function);
        void Reconnect();

    private:
        std::thread recvTask;
        int m_socket_fd;
        std::thread connectTask;
        bool m_is_connected;
        std::function<void(std::string)> m_callback_func;
        bool m_recv;
        bool m_connect;

    private:
        BinarySocketRet Pri_CreateClientSocket();
        BinarySocketRet Pri_CloseClientSocket();
        void Pri_ConnectSocket();
        void Pri_TaskThread();
};